﻿using System;
using System.Windows;
using System.Windows.Controls;
using Telerik.Windows.Examples.Map.DataBinding;
using Telerik.Windows.Controls.Map;
using System.Windows.Data;

namespace SilverlightMapApplication
{
    public partial class MainPage : UserControl
    {
        private string VEKey = @"< Your bing key goes here >";
        private POICollection poiCollection = new POICollection();

        public MainPage()
        {
            this.InitializeComponent();

            this.SetProvider();

            this.InformationLayer1.ItemTemplateSelector = new WayPointTemplateSelector(
                this.LayoutRoot.Resources["LeftWayPointTemplate"] as DataTemplate,
                this.LayoutRoot.Resources["CenterWayPointTemplate"] as DataTemplate,
                this.LayoutRoot.Resources["RightWayPointTemplate"] as DataTemplate,
                this.LayoutRoot.Resources["DetailWayPointTemplate"] as DataTemplate);

            this.InformationLayer2.DataMappings.Clear();
            this.InformationLayer2.DataMappings.Add(
                new DataMapping("Location", DataMember.Location));

            Binding binding = new Binding();
            binding.Source = this.poiCollection;
            this.InformationLayer3.SetBinding(ItemsControl.ItemsSourceProperty, binding);
        }

        // Initialize Virtual Earth map provider.
        private void SetProvider()
        {
            BingMapProvider provider = new BingMapProvider(MapMode.Aerial, true, this.VEKey);
            this.RadMap1.Provider = provider;
        }

        private void RadMap1_InitializeCompleted(object sender, EventArgs e)
        {
            this.InformationLayer1.Visibility = Visibility.Visible;
            this.InformationLayer2.Visibility = Visibility.Visible;
            this.InformationLayer3.Visibility = Visibility.Visible;
        }

        private void RadMap1_MapMouseClick(object sender, MapMouseRoutedEventArgs eventArgs)
        {
            // Create new map item.
            PointOfInterest item = new PointOfInterest();
            item.Title = string.Format("Lat: {0:F4}, Lon: {1:F4}",
                                       eventArgs.Location.Latitude,
                                       eventArgs.Location.Longitude);
            item.Location = eventArgs.Location;
            item.BaseZoomLevel = this.RadMap1.ZoomLevel;
            item.ZoomRange = new ZoomRange(this.RadMap1.ZoomLevel - 2, this.RadMap1.ZoomLevel + 2);

            this.poiCollection.Add(item);
        }
    }
}