﻿using System.Windows;
using Telerik.Windows.Controls.Map;

namespace Telerik.Windows.Examples.Map.DataBinding
{
    public class WayPointTemplateSelector : MapDataTemplateSelector
    {
        private DataTemplate leftTemplate;
        private DataTemplate centerTemplate;
        private DataTemplate rightTemplate;
        private DataTemplate detailTemplate;

        public WayPointTemplateSelector(DataTemplate leftTemplate, DataTemplate centerTemplate, DataTemplate rightTemplate, DataTemplate detailTemplate)
        {
            this.leftTemplate = leftTemplate;
            this.centerTemplate = centerTemplate;
            this.rightTemplate = rightTemplate;
            this.detailTemplate = detailTemplate;
        }

        public override DataTemplate SelectTemplate(object item, DependencyObject container)
        {
            Location mapItem = (Location)item;
            if (mapItem != null)
            {
                if (this.Layer.MapControl.ZoomLevel < 12)
                {
                    if (mapItem.Longitude > 10.1076291138805)
                    {
                        return this.rightTemplate;
                    }
                    else if (mapItem.Longitude < 10.1076291138805)
                    {
                        return this.leftTemplate;
                    }
                    else
                    {
                        return this.centerTemplate;
                    }
                }
                else
                {
                    return this.detailTemplate;
                }
            }
            return base.SelectTemplate(item, container);
        }
    }
}